Unit tde52r_p;
{$J+}
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UtRes_p, FDE52R_p, DE52R_p;

function tde52r: String;

implementation

function tde52r: String;
var
K,M,NXS,NXO,I,_i,IERR :Integer;
XN,HMIN,EPS,P,H :Real;
BUL :Boolean;
IRAB :Array [0..3] of Integer;
XS :Array [0..1] of Real;
XO :Array [0..19] of Real;
U :Array [0..15] of Real;
YR :Array [0..11] of Real;
RK :Array [0..15] of Real;
T :Array [0..5] of Real;
Y :Array [0..7] of Real;
const
C :Array [0..9] of Real = ( 1.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.146996,
0.0241005 );
B :Array [0..9] of Real = ( 1.0,0.0,0.0,1.0,0.0,0.0,0.0,0.0,0.0,0.0 );
label
_1;
begin
Result := '';  {   }
K := 2;
M := 4;
XN := 0.0;
NXS := 2;
XS[0] := 1.0;
XS[1] := 0.0;
HMIN := 1.E-14;
//HMIN := 1.E-10;
EPS := 1.E-14;
//EPS := 1.E-7;
P := 0.1E-10;
//P := 1.E-7;
NXO := 10;
H := 0.1;
XO[0] := H;
for I:=2 to NXO do
 begin
_1:
  XO[I-1] := XO[I-2]+H;
 end;
BUL := True;
DE52R(FDE52R,M,XN,NXS,XS,HMIN,EPS,P,NXO,XO,K,BUL,B,
     C,Y,U,IRAB,YR,RK,T,IERR);
Result := Result + #$0D#$0A;
Result := Result + '  XS' + #$0D#$0A + #$0D#$0A;
for _i:=0 to 1 do
 begin
  Result := Result + Format('%20.16f ',[XS[_i]]);
  if ( ((_i+1) mod 2)=0 )
   then Result := Result + #$0D#$0A;
 end;
Result := Result + #$0D#$0A;
Result := Result + '  Y  (     M * NXS)' + #$0D#$0A + #$0D#$0A;
for _i:=0 to 7 do
 begin
  Result := Result + Format('%20.16f ',[Y[_i]]);
  if ( ((_i+1) mod M)=0 )
   then Result := Result + #$0D#$0A;
 end;
Result := Result + #$0D#$0A;
Result := Result + #$0D#$0A + '  IERR =' + Format('%2d ',[IERR]);
UtRes('tde52r',Result);  {     tde52r.res }
exit;
end;

end.
